#pragma once
/** @file This file simply contains forward definitions of many frequently-used classes and types within the WM core.
*/
#include <boost/smart_ptr.hpp>
namespace WorldMachine {
	class RunFunctionInterface;
};

class Device;
class DeviceWorld;
class RenderExtent;
struct WorldCommonData;

class LayoutUIClient;

class DeviceResults;
class BuildResultSet;
class DeviceWorldBuilder;

class PacketContext;
class BuildContext;

template <class T> class Vector2Typ;
typedef Vector2Typ<float> Vector2;
typedef Vector2Typ<double> Vector2D;
class Vector3;

struct Coord;
typedef Vector2 CoordF;

struct Rect;
struct RectF;
struct Rect4F;
class Polygon2;


class WMPacket;
class HField;
class BMPacket;
class CoordPacket;
class ParamPacket;
class ScalarPacket;
class TerrainComboPacket;
class MeshPacket;
class TextPacket;
class WMAreaPacket;

typedef boost::intrusive_ptr<WMPacket> PacketPointer;
typedef boost::intrusive_ptr<HField> HFPointer;
typedef boost::intrusive_ptr<BMPacket> BMPointer;
typedef boost::intrusive_ptr<CoordPacket> CoordPointer;
typedef boost::intrusive_ptr<ParamPacket> ParamPointer;
typedef boost::intrusive_ptr<ScalarPacket> ScalarPointer;
typedef boost::intrusive_ptr<TerrainComboPacket> TCPointer;
typedef boost::intrusive_ptr<MeshPacket> MeshPointer;
typedef boost::intrusive_ptr<TextPacket> TextPointer;
typedef boost::intrusive_ptr<WMAreaPacket> AreaPointer;